*** pixutils.c	2004/05/07 19:46:16	1.1
--- pixutils.c	2005/01/16 20:25:17
***************
*** 2253,2258 ****
--- 2312,2838 ----
  }
  
  
+ 
+ 
+ 
+ #define xderiv 0
+ #define yderiv 1
+ #define xxderiv 2
+ #define xyderiv 3
+ #define yyderiv 4
+ 
+ #define xsub 0
+ #define ysub 1
+ #define zsub 2
+ 
+ #define sstep 15
+ 
+ 
+ #define YCIRCPIXEL                                             \
+ offset1 = (Long)((C[ysub]+dy)*View.yskip+(C[xsub]+dx));        \
+ offset2 = (Long)((C[ysub]-dy)*View.yskip+(C[xsub]-dx));        \
+ inten = LightDot(dx+C[xsub]-A[xsub],                           \
+                  dy+C[ysub]-A[ysub],                           \
+                  dz+C[zsub]-A[zsub]);                          \
+ if ( inten > 0 ) {                                             \
+     inten = (int)((inten*colconst(rada))>>ColBits);            \
+ } else {                                                       \
+     inten = 0;                                                 \
+ }                                                              \
+ if (inten > ColourMask) inten = ColourMask;                    \
+ if( OValid(offset1) && XValid(C[xsub]+dx) &&                   \
+     YValid(C[ysub]+dy) &&                                      \
+     ZValid(C[zsub]+dz) &&                                      \
+     ZBack(C[zsub]+dz) ){                                       \
+     SETPIXEL(View.dbuf+offset1,                                \
+              View.fbuf+offset1,C[zsub]+dz,Lut[c+inten]);       \
+ }                                                              \
+ inten = LightDot(-dx+C[xsub]-A[xsub],                          \
+                  -dy+C[ysub]-A[ysub],                          \
+                  -dz+C[zsub]-A[zsub]);                         \
+ if ( inten > 0 ) {                                             \
+     inten = (int)((inten*colconst(rada))>>ColBits);            \
+ } else {                                                       \
+     inten = 0;                                                 \
+ }                                                              \
+ if (inten > ColourMask) inten = ColourMask;                    \
+ if( OValid(offset2) && XValid(C[xsub]-dx) &&                   \
+     YValid(C[ysub]-dy) &&                                      \
+     ZValid(C[zsub]-dz) &&                                      \
+     ZBack(C[zsub]-dz) ){                                       \
+     SETPIXEL(View.dbuf+offset2,                                \
+              View.fbuf+offset2,C[zsub]-dz,Lut[c+inten]);       \
+ }
+ 
+ #ifdef __MC68K__
+ #define SMALLER 1
+ #endif
+ 
+ #ifdef SMALLER
+ #define XCIRCPIXEL CircPixel(dx,dy,dz);
+ void CircPixel( Long dx, Long dy, Long dz) {
+     register int inten;
+     register Long offset1, offset2;
+     YCIRCPIXEL
+ }
+ #else
+ #define XCIRCPIXEL YCIRCPIXEL
+ #endif
+ 
+ 
+ #define CIRCPIXEL                                              \
+ if (s == 0 ) { if (NDots < ARCSIZE) {                          \
+    (NCircle[NDots]).dx = dx;                                   \
+    (NCircle[NDots]).dy = dy;                                   \
+    (NCircle[NDots]).dz = dz;                                   \
+    (NCircle[NDots]).inten = brushdir;                          \
+     NDots++;                                                   \
+    /* fprintf(stderr,"dx, dy, dz, brushdir, G, F, Gxup, Gyup, {%ld, %ld, %ld}, %d, %ld, %ld, %ld, %ld\n",    \
+    dx, dy, dz, brushdir, G, F, Gxup, Gyup);                */   \
+ } else {NR = -1;}   }                                          \
+ {XCIRCPIXEL}
+ 
+ #define CIRCDOZ                                                \
+ if (AbsFun(F+SBD.U[SBD.s2]) < AbsFun(F) ) {                    \
+   {CIRCPIXEL}; (*ds2)++; F+=SBD.U[SBD.s2];                     \
+  } else {                                                      \
+   if (AbsFun(F-SBD.U[SBD.s2]) < AbsFun(F) ) {                  \
+     {CIRCPIXEL}; (*ds2)--; F-=SBD.U[SBD.s2];                   \
+   }                                                            \
+ }
+ 
+ 
+ #define CIRCUP                                                 \
+ G += Gyup; Gxup += 2*(SBD.Us0Us1); Gxdown -= 2*(SBD.Us0Us1);   \
+ Gyup += 2*(SBD.Us1Us1_Us2Us2);                                 \
+ Gydown -= 2*(SBD.Us1Us1_Us2Us2);                               \
+ F += SBD.U[SBD.s1]; (*ds1)++;                                  \
+ CIRCDOZ
+ 
+ 
+ #define CIRCDOWN                                               \
+ G += Gydown; Gxup -= 2*(SBD.Us0Us1); Gxdown += 2*(SBD.Us0Us1); \
+ Gyup -= 2*(SBD.Us1Us1_Us2Us2);                                 \
+ Gydown += 2*(SBD.Us1Us1_Us2Us2);                               \
+ F -= SBD.U[SBD.s1]; (*ds1)--;                                  \
+ CIRCDOZ
+ 
+ 
+ #define CIRCRIGHT                                              \
+ G += Gxup; Gxup += 2*( SBD.Us0Us0_Us2Us2 );                    \
+ Gxdown -= 2*(SBD.Us0Us0_Us2Us2);                               \
+ Gyup += 2*((SBD.Us0Us1)); Gydown -= 2*((SBD.Us0Us1));          \
+ F += SBD.U[SBD.s0]; (*ds0)++;                                  \
+ CIRCDOZ
+ 
+ 
+ 
+ 
+ void DrawCircle( void ) {
+ 	Long dx, dy, dz;
+ 	register Long offset1, offset2;
+ 	register Long F, G, FS, s2S, Gxup, Gxdown, Gyup, Gydown;
+ 	register int inten;
+ 	int spandex, s, w;
+ 	int rdir, cdir, ii;
+ 	Long * ds[3];
+ 	register Long *ds0, *ds1, *ds2;
+ 	long Xmin, Ymin, Xmax, Ymax, Xpeak;
+ 	int updown, ifirst;
+ 	register int brush, brushdir;
+ 	double rinc;
+ 	
+ 	
+ 	rdir = (radnext-radprev)==0?0:((radnext-radprev<0)?-1:1);
+ 	cdir = (Cnext[SBD.s2]-Cprev[SBD.s2])==0?0:((Cnext[SBD.s2]-Cprev[SBD.s2]<0)?-1:1);
+ 	
+ 	
+ 	ds[0] = &dx;
+ 	ds[1] = &dy;
+ 	ds[2] = &dz;
+ 	
+ 	C[0] = Cnext[0]; C[1] = Cnext[1]; C[2] = Cnext[2];
+ 	spandex = 1+AbsFun(rdir)+AbsFun(Cnext[SBD.s2]-Cprev[SBD.s2]);
+ 	w = 0;
+ 	ifirst = 0;
+ 	
+ 	ds0 = ds[SBD.s0]; ds1 = ds[SBD.s1]; ds2 = ds[SBD.s2];
+ 	
+ 	do {
+ 	  if (w == 0) {
+ 	    brush = 2*AbsFun(radnext-radprev) + 2 + max(AbsFun(Cnext[SBD.s0]-Cprev[SBD.s0]), AbsFun(Cnext[SBD.s1]-Cprev[SBD.s1])); 
+ 	    rad = radnext>radprev?radnext:radprev;
+ 		w+=AbsFun (rdir);
+ 		if (w == 0) {w++; spandex++;}
+ 	  } else {
+ 	    Long rat;
+ 		
+ 		if (cdir == 0) break;
+ 		brush = 2;
+ 		switch (ifirst) {
+ 		  case 0:  C[SBD.s2] -= cdir;
+ 				if (Cnext[SBD.s0]-Cprev[SBD.s0] == 0) ifirst++;
+ 				break;
+ 		  case 1:  rat = (4096*(Cnext[SBD.s2]-C[SBD.s2]))/(Cnext[SBD.s2]-Cprev[SBD.s2]);
+ 		        C[SBD.s0] = (rat*Cprev[SBD.s0]+(4096-rat)*Cnext[SBD.s0])/4096;
+ 				if (Cnext[SBD.s1]-Cprev[SBD.s1] == 0) ifirst++;
+ 				break;
+ 		  case 2:  rat = (4096*(Cnext[SBD.s2]-C[SBD.s2]))/(Cnext[SBD.s2]-Cprev[SBD.s2]);
+ 		        C[SBD.s1] = (rat*Cprev[SBD.s1]+(4096-rat)*Cnext[SBD.s1])/4096;
+ 		        break;
+ 		}
+ 		
+ 		ifirst++; if (ifirst==3) {w++; ifirst=0;}
+ 	  }
+ 	  if (brush > rad) brush = rad;
+ 	
+ 	
+ 	// now |U[SBD.s0]| <= |U[SBD.s1]| <= |U[SBD.s2]|, draw an s0-s1 curve
+ 		
+ 		rada = (int)(.5+sqrt(
+ 							  (double)(rad*rad+(C[0]-A[0])*(C[0]-A[0])
+ 									   +(C[1]-A[1])*(C[1]-A[1])
+ 									   +(C[2]-A[2])*(C[2]-A[2]))));
+ 	     /*
+ 		 if (OR > 0 && rad <= OR && 2*rad> OR) {
+ 			double rat = ((double)rad)/((double)OR);
+ 			for (ii=0; ii<ODots; ii++) {
+ 				dx = rint(rat*(OCircle[ii]).dx);
+ 				dy = rint(rat*(OCircle[ii]).dy);
+ 				dz = rint(rat*(OCircle[ii]).dz);
+ 				brushdir = OCircle[ii].inten;
+ 				F = dx*SBD.U[0] + dy*SBD.U[1] + dz*SBD.U[2];
+ 				{XCIRCPIXEL}
+ 				for (s = 1; s < brush; s++) {	
+ 					switch (brushdir) 
+ 					{
+ 						case 0:  (*ds0)++; F += SBD.U[SBD.s0]; break;
+ 						case 1:  (*ds0)++; F += SBD.U[SBD.s0]; {CIRCDOZ} {XCIRCPIXEL}; 
+ 						case 2:  (*ds1)--; F -= SBD.U[SBD.s1]; break;
+ 						case 3:  (*ds0)--; F -= SBD.U[SBD.s0]; {CIRCDOZ} {XCIRCPIXEL}; 
+ 								 (*ds1)--; F -= SBD.U[SBD.s1]; break;
+ 						case 4:  (*ds0)--; F -= SBD.U[SBD.s0]; break;
+ 					}
+ 					{CIRCDOZ} {XCIRCPIXEL}
+ 				}
+ 			}
+ 			continue;
+ 		}
+ 		*/
+ 		NDots = 0;
+ 		NR = rad;
+ 		
+ 		Xmin = - (Xmax =
+ 				  (Long)(rint((double)(rad))*(sqrt((double)(SBD.Us1Us1_Us2Us2)))/
+ 						 sqrt((double)(SBD.Us0Us0_Us1Us1_Us2Us2))));
+ 		
+ 		if ( Xmax > rad) {
+ 			Xmin = -(Xmax=rad);
+ 		}
+ 		Ymax = -(Long)(rint((double)(rad*(SBD.Us0Us1)))/
+ 					   ( sqrt((double)(SBD.Us1Us1_Us2Us2))*
+ 						 sqrt((double)(SBD.Us0Us0_Us1Us1_Us2Us2)) ));
+ 		Ymin = -Ymax;
+ 		if ( Ymax > rad ) {
+ 			Ymin = -(Ymax=rad);
+ 		}
+ 		Xpeak = -(Long)(rint((double)(rad*(SBD.Us0Us1)))/
+ 					   ( sqrt((double)(SBD.Us0Us0_Us2Us2))*
+ 						 sqrt((double)(SBD.Us0Us0_Us1Us1_Us2Us2)) ));
+ 		*ds0 = Xmin;
+ 		*ds1 = Ymin;
+ 		
+ 		
+ 		G = Xmin*Xmin*(SBD.Us0Us0_Us2Us2)+Ymin*Ymin*(SBD.Us1Us1_Us2Us2)  +
+ 			2*Xmin*Ymin*(SBD.Us0Us1) - rad*rad*SBD.U[SBD.s2]*SBD.U[SBD.s2];
+ 		Gxup = (2*Xmin+1)*(SBD.Us0Us0_Us2Us2) + 2*Ymin*(SBD.Us0Us1);
+ 		Gyup = (2*Ymin+1)*(SBD.Us1Us1_Us2Us2) + 2*Xmin*(SBD.Us0Us1);
+ 		Gxdown = (-2*Xmin+1)*(SBD.Us0Us0_Us2Us2) - 2*Ymin*(SBD.Us0Us1);
+ 		Gydown = (-2*Ymin+1)*(SBD.Us1Us1_Us2Us2) - 2*Xmin*(SBD.Us0Us1);
+ 		*ds2= (int)(rint(-(double)((*ds0)*SBD.U[SBD.s0]+(*ds1)*SBD.U[SBD.s1]))/((double)SBD.U[SBD.s2]));
+ 		F = dx*SBD.U[0] + dy*SBD.U[1] + dz*SBD.U[2];
+ 		FS = F;
+ 		s2S = *ds2;
+ 		brushdir = 0;
+ 		for (s=0; s< brush; s++) {
+ 		    CIRCPIXEL
+ 			(*ds0)++;
+ 			F += SBD.U[SBD.s0];
+             CIRCDOZ
+ 		}
+ 		(*ds0)-=brush;
+ 		updown = 1;
+ 		F = FS;
+ 		*ds2 = s2S;
+ 		
+ 		/*
+ 		                      Gxup small
+ 		                      Gyup > 0
+ 						     ----------
+ 						   /\  | | | | /\
+ 						  /\1     2    3/\
+ 			Gxup < 0     | ----       ----|  Gxup > 0
+ 		   Gyup small	 | -0-        --4-|  Gydown small
+ 		 
+ 		 
+ 		 */
+ 		
+ 		
+ 		while ((*ds0 < Xmax )|| (*ds0 == Xmax && *ds1 > Ymax)) {  /* Start by going up and right */
+ 			if ( (3*(*ds0) < 2*Xmin + Xpeak) ) { 
+ 				brushdir = 0;
+ 			} else {
+ 			    if ( (3*(*ds0) < Xmin +2*Xpeak) ) {
+ 				brushdir = 1;
+ 				} else {
+ 				  if ( (3*(*ds0) < 2*Xpeak+ Xmax)  ) { 
+ 				  brushdir = 2;
+ 				  } else {
+ 				    if ( (3*(*ds0) < Xpeak + 2*Xmax) ) {
+ 				      brushdir = 3;
+ 					} else {
+ 				      brushdir = 4;
+ 					}
+ 				  }
+ 				} 
+ 		    }
+ 			if (*ds0 < Xpeak) {
+ 			  if ( (AbsFun(G+Gyup) < AbsFun(G+Gxup)) ||
+ 				             (AbsFun(G+Gyup+Gxup+2*(SBD.Us0Us1)) < AbsFun(G+Gxup))) {
+ 				      {CIRCUP}
+ 				      if (AbsFun(G+Gxup) < AbsFun(G) ) {CIRCRIGHT}
+ 				} else {
+ 				{CIRCRIGHT}
+ 				}
+ 			} else {
+ 				if (((AbsFun(G+Gydown) < AbsFun(G+Gxup))  ||
+ 					 (AbsFun(G+Gydown+Gxup-2*(SBD.Us0Us1)) < AbsFun(G+Gxup))     ) || 
+ 					(*ds0 == Xmax && *ds1 > Ymax)){
+ 				{CIRCDOWN}
+ 					if ((AbsFun(G+Gxup) < AbsFun(G)) && *ds0 < Xmax) {CIRCRIGHT}
+ 				} else {
+ 				{CIRCRIGHT}
+ 				}
+ 			}
+ 			FS = F;
+ 			s2S = *ds2;
+             switch(brushdir) {
+ 				/* Starting on the left side of the ellipse */
+ 				case 0: 
+ 					for (s = 0; s < brush; s++) {
+ 					  {CIRCPIXEL}
+ 					  (*ds0)++; F += SBD.U[SBD.s0]; /* go right */
+ 					  {CIRCDOZ}
+ 					}
+ 					(*ds0)-=brush;
+ 					break;
+ 					/* Continue on the upslope of the left side of the ellipse */
+ 				case 1:  
+ 					for (s = 0; s < brush; s++) {
+ 					  {CIRCPIXEL}
+ 					  (*ds0)++; F+= SBD.U[SBD.s0];
+ 					  {CIRCDOZ}
+ 					  if ( s > 0 ){CIRCPIXEL}; 
+ 					  (*ds1)--; F=-SBD.U[SBD.s1]; /* go down right */
+ 					  {CIRCDOZ}
+ 					}
+ 					(*ds0)-=brush; (*ds1)+=brush;
+ 					break;
+ 					/* Continue on the top of the ellipse */
+ 				case 2:  
+ 					for (s = 0; s < brush; s++) {
+ 					  {CIRCPIXEL}
+ 					  (*ds1)--; F-= SBD.U[SBD.s1]; /* go down */
+ 					  {CIRCDOZ}
+ 					}
+ 					(*ds1)+=brush;
+ 					break;
+ 					/* Continue on the down slope of the right of the ellipse */
+ 				case 3:   
+ 					for (s = 0; s < brush; s++) {
+ 					  {CIRCPIXEL}
+ 					  (*ds0)--; F-=SBD.U[SBD.s0];
+ 					  {CIRCDOZ}
+ 					  if ( s > 0 ) {CIRCPIXEL};
+ 					  (*ds1)--; F-=SBD.U[SBD.s1]; /* go down left */
+ 					  {CIRCDOZ}
+ 					}
+ 					(*ds0)+=brush; (*ds1)+=brush;
+ 					break;
+ 					/* Finish on the right side of the ellipse */
+ 				case 4:  
+ 					for (s = 0; s < brush; s++) {
+ 					  {CIRCPIXEL}
+ 					  (*ds0)--; F -= SBD.U[SBD.s0]; /* go right */
+ 					  {CIRCDOZ}
+ 					}
+ 					(*ds0)+=brush;
+ 					break;
+ 			}
+ 			F = FS;
+ 			*ds2 = s2S;
+ 			
+ 		}
+ 		if ( NR > 0 ) {
+ 			TCircle = OCircle;
+ 			OCircle = NCircle;
+ 			NCircle = TCircle;
+ 			OR = rad;
+ 			ODots = NDots;
+ 		}
+         continue;
+ 		} while (w < spandex);
+ }
+ 
+ 
+ void DrawTorus( int x1, int y1, int z1,
+                               int x2, int y2, int z2,
+                               int c1, int c2,
+                               int xrad1, int xrad2, int radp, char altl )
+ {
+ 
+     double ccen;
+     int oClipStatus;
+     
+     register int altc;
+     Long s, smax, t, u;
+     int rad;
+ 
+ 
+     altc=0;
+     if (altl != '\0' && altl != ' ')
+       altc = AltlColours[((int)altl)&(AltlDepth-1)];
+ 
+ 
+     c = c1;
+ 
+     rad = -1;
+     OR = NR = -1;
+     OCircle = ArcAc;
+     NCircle = ArcDn;
+ 	smax = SBD.t1;
+     
+     for (u = SBD.t1; u <= SBD.sxyz-SBD.t2+2*sstep; u+=sstep ) {
+ 	  if ( u < SBD.u1+sstep ) {
+ 	    smax = s = u;
+ 	  } else {
+ 	    s = SBD.sxyz - SBD.t2 + smax+sstep-u;
+         if (s >= SBD.sxyz-SBD.t2 ) {
+             rad = -1;
+             c = c2;
+         }
+ 	  }
+ 
+       if (rad != -1 ) {
+           Cprev[xsub] = Cnext[xsub]; Cprev[ysub] = Cnext[ysub]; Cprev[zsub] = Cnext[zsub];
+       }
+       Cnext[xsub] = ((SBD.sxyz-s)*((Long)SBD.x1)+s*((Long)SBD.x2))/((Long)SBD.sxyz);
+       Cnext[ysub] = ((SBD.sxyz-s)*((Long)SBD.y1)+s*((Long)SBD.y2))/((Long)SBD.sxyz);
+       Cnext[zsub] = ((SBD.sxyz-s)*((Long)SBD.z1)+s*((Long)SBD.z2))/((Long)SBD.sxyz);
+       radnext = (int)(SBD.wp>>4) - pythag(radp,AbsFun((int)((s-SBD.u1)>>4)));
+       if (radnext <0 ) {
+           rad = -1;
+           continue;
+       }
+       if (rad == -1 ) {
+           Cprev[xsub] = Cnext[xsub]; Cprev[ysub] = Cnext[ysub]; Cprev[zsub] = Cnext[zsub];
+       } else {
+           if (Cprev[xsub] == Cnext[xsub] && Cprev[ysub] == Cnext[ysub] && Cprev[zsub] == Cnext[zsub]) continue;
+       }
+       radnext = AbsFun(radnext);
+       if (rad == -1) rad = radnext;
+       radprev = rad;
+       rad = radnext;
+       
+       if (u <= SBD.u1) {
+         ccen = ((double)(SBD.u1-s))/16.;
+         t = SBD.u1 - (Long)rint(((double)(SBD.wp))*ccen/sqrt((double)(radp*radp)-ccen*ccen));
+       } else {
+         ccen = ((double)(SBD.u2-(SBD.sxyz-s)))/16.;
+         t = SBD.u2 - (Long)rint(((double)(SBD.wp))*ccen/sqrt((double)(radp*radp)-ccen*ccen));
+         t = SBD.sxyz - t;
+       }
+       A[xsub] = ((SBD.sxyz-t)*((Long)SBD.x1)+t*((Long)SBD.x2))/((Long)SBD.sxyz);
+       A[ysub] = ((SBD.sxyz-t)*((Long)SBD.y1)+t*((Long)SBD.y2))/((Long)SBD.sxyz);
+       A[zsub] = ((SBD.sxyz-t)*((Long)SBD.z1)+t*((Long)SBD.z2))/((Long)SBD.sxyz);
+ 
+       if (ClipStatus) {
+           oClipStatus = ClipStatus;
+           rada = (int)(.99+sqrt(
+                 (double)(rad*rad+
+                 (Cnext[0]-A[0])*(Cnext[0]-A[0])+
+                 (Cnext[1]-A[1])*(Cnext[1]-A[1])+
+                 (Cnext[2]-A[2])*(Cnext[2]-A[2]))));
+           if (TestSphere(A[0],A[1],A[2],rada)) {
+               if ( (ClipStatus&BitFront) ) {
+                   ClipSphere(A[0],A[1],A[2],rada,c);
+                   rad = -1;
+               } else {
+                   DrawCircle();
+               }
+           }
+           ClipStatus = oClipStatus;
+       } else {
+       DrawCircle();
+       }
+ 
+       if ( altc && s-SBD.u1 < (SBD.sxyz-SBD.t2-SBD.t1)/2 
+                 && SBD.u1-s < (SBD.sxyz-SBD.t2-SBD.t1)/2 ) {
+        c = altc;
+       } else {
+          if (s >= SBD.u1) c = c2;
+       }
+     }
+ 
+ }
+ 
+ 
+ 
+ static int TestSurfaceBond( int x1, int y1, int z1,
+                               int x2, int y2, int z2,
+                               int xrad1, int xrad2, int radp )
+ {
+     ClipStatus = False;
+ 
+     if ( x1+xrad1 < 0 && x2+xrad2 < 0 ) return False;
+     if ( x1-xrad1 >= View.xmax && x2-xrad2 >= View.xmax ) return False;
+ 
+     if ( y1+xrad1 < 0 && y2+xrad2 < 0 ) return False;
+     if ( y1-xrad1 >= View.ymax && y2-xrad2 >= View.ymax ) return False;
+ 
+     if ( UseSlabPlane ) {
+         if ( z1-xrad1 >= SlabValue && z2-xrad1 >= SlabValue ) return False;
+     }
+ 
+     if ( UseDepthPlane ) {
+         if ( z1+xrad1 <= DepthValue && z2+xrad2 <= DepthValue ) return False;
+     }
+ 
+     if ( x1-xrad1 < 0 || x2-xrad2 < 0 ||
+          x1+xrad1 >= View.xmax || x2+xrad2 >= View.xmax ||
+          y1-xrad1 < 0 || y2-xrad2 < 0 ||
+          y1+xrad1 >= View.ymax || y2+xrad2 >= View.ymax ) ClipStatus = True;
+     if ( UseSlabPlane ) {
+         if ( z1+xrad1 > SlabValue || z2+xrad2 > SlabValue) ClipStatus = True;
+     }
+     if ( UseDepthPlane ) {
+         if ( z1-xrad1 < DepthValue || z2-xrad2 > DepthValue) ClipStatus = True;
+     }
+     return True;
+ }
+ 
+ void ClipSurfaceBond( int x1, int y1, int z1,
+                               int x2, int y2, int z2,
+                               int c1, int c2,
+                               int xrad1, int xrad2, int radp, char altl )
+ {
+     if (!TestSurfaceBond(x1,y1,z1,x2,y2,z2,xrad1,xrad2,radp) ) return;
+     /* DrawEllipses( x1,y1,z1, x2,y2,z2,  c1,c2, xrad1,xrad2,radp, altl ); */
+     DrawTorus( x1,y1,z1, x2,y2,z2,  c1,c2, xrad1,xrad2,radp, altl );
+ 
+ }
+ 
+ 
  static void DrawCylinderCaps( int x1, int y1, int z1,
                                int x2, int y2, int z2,
                                int c1, int c2, int rad, char altl )
***************
*** 2291,2310 ****
      fold = View.fbuf+temp;
      dold = View.dbuf+temp;
  
      ArcAcPtr = ArcAc;
      ArcDnPtr = ArcDn;
  
      temp = (Long)-(rad*View.yskip);
      for( dy= -rad; dy<=rad; dy++ )
!     {   wide = LookUp[rad][AbsFun(dy)];
          alts = 0;
  
          for( dx= -wide; dx<=wide; dx++ )
          {   absx = AbsFun(dx);
!             dz = LookUp[wide][absx];
              inten = LightDot(dx,dy,dz);
              if( inten>0 )
!             {   inten = (int)((inten*ColConst[rad])>>ColBits);
              } else inten = 0;
              offset = temp+dx;
  
--- 2871,2893 ----
      fold = View.fbuf+temp;
      dold = View.dbuf+temp;
  
+     if ( rad < 0 ) rad = 0;
+     if ( rad >= MAXRAD ) rad = MAXRAD-1; 
+ 
      ArcAcPtr = ArcAc;
      ArcDnPtr = ArcDn;
  
      temp = (Long)-(rad*View.yskip);
      for( dy= -rad; dy<=rad; dy++ )
!     {   wide =pythag(rad,AbsFun(dy));
          alts = 0;
  
          for( dx= -wide; dx<=wide; dx++ )
          {   absx = AbsFun(dx);
!             dz = pythag(wide,absx);
              inten = LightDot(dx,dy,dz);
              if( inten>0 )
!             {   inten = (int)((inten*colconst(rad))>>ColBits);
              } else inten = 0;
              offset = temp+dx;
  
***************
*** 2328,2353 ****
              k1 = AbsFun(dx+ix); 
              k2 = AbsFun(dx-ix);
  
!             if( ((k1>wide)||(dz>=LookUp[wide][k1]-zrate)) &&
!                 ((k2>wide)||(dz>LookUp[wide][k2]+zrate)) )
  #endif
              {   ArcAcPtr->offset = offset; ArcAcPtr->inten = inten;
                  ArcAcPtr->dx=dx; ArcAcPtr->dy=dy; ArcAcPtr->dz=dz;
                  ArcAcPtr++;
!             }
  
  #ifdef UNUSED
              k1 = AbsFun(dy+iy);
              k2 = AbsFun(dy-iy);
  
!             high = LookUp[rad][absx];
!             if( ((k1>high)||(dz>=LookUp[LookUp[rad][k1]][absx]-zrate)) &&
!                 ((k2>high)||(dz>LookUp[LookUp[rad][k2]][absx]+zrate)) )
  #endif
              {   ArcDnPtr->offset = offset; ArcDnPtr->inten = inten;
                  ArcDnPtr->dx=dx; ArcDnPtr->dy=dy; ArcDnPtr->dz=dz;
                  ArcDnPtr++;
!             }
          }
          temp += View.yskip;
      }
--- 2911,2938 ----
              k1 = AbsFun(dx+ix); 
              k2 = AbsFun(dx-ix);
  
!             if( ((k1>wide)||(dz>=pythag(wide,k1)-zrate)) &&
!                 ((k2>wide)||(dz>pythag(wide,k2)+zrate)) )
  #endif
+             if ( (ArcAcPtr-ArcAc)<ARCSIZE ) {
              {   ArcAcPtr->offset = offset; ArcAcPtr->inten = inten;
                  ArcAcPtr->dx=dx; ArcAcPtr->dy=dy; ArcAcPtr->dz=dz;
                  ArcAcPtr++;
!             } }
  
  #ifdef UNUSED
              k1 = AbsFun(dy+iy);
              k2 = AbsFun(dy-iy);
  
!             high = pythag(rad,absx);
!             if( ((k1>high)||(dz>=pythag(pythag(rad,k1),absx)-zrate)) &&
!                 ((k2>high)||(dz>pythag(pythag(rad,k2),absx)+zrate)) )
  #endif
+             if ( (ArcDnPtr-ArcDn)<ARCSIZE ) {
              {   ArcDnPtr->offset = offset; ArcDnPtr->inten = inten;
                  ArcDnPtr->dx=dx; ArcDnPtr->dy=dy; ArcDnPtr->dz=dz;
                  ArcDnPtr++;
!             } }
          }
          temp += View.yskip;
      }
***************
*** 2562,2573 ****
  
      ptr = ArcAc;
      while( (temp=y+ptr->dy) < 0 )
!         if( ++ptr == ArcAcPtr )
              return;
  
      while( (temp<View.ymax) && (ptr<ArcAcPtr) )
      {   temp = x+ptr->dx;
!         if( XValid(temp) )
          {   dptr = dbase+ptr->offset;  depth = ptr->dz+z;
              SETPIXEL(dptr,fbase+ptr->offset,depth,Lut[ptr->inten+c]);
          }
--- 3147,3158 ----
  
      ptr = ArcAc;
      while( (temp=y+ptr->dy) < 0 )
!         if(++ptr == ArcAcPtr )
              return;
  
      while( (temp<View.ymax) && (ptr<ArcAcPtr) )
      {   temp = x+ptr->dx;
!         if( XValid(temp) && OValid(ptr->offset) )
          {   dptr = dbase+ptr->offset;  depth = ptr->dz+z;
              SETPIXEL(dptr,fbase+ptr->offset,depth,Lut[ptr->inten+c]);
          }
***************
*** 2586,2598 ****
      register int temp;
  
      ptr = ArcDn;
      while( (temp=y+ptr->dy) < 0 )
!         if( ++ptr == ArcDnPtr )
              return;
  
!     while( (temp<View.ymax) && (ptr<ArcDnPtr) )
      {   temp = x+ptr->dx;
!         if( XValid(temp) )
          {   dptr = dbase+ptr->offset;  depth = ptr->dz+z;
              SETPIXEL(dptr,fbase+ptr->offset,depth,Lut[ptr->inten+c]);
          }
--- 3171,3184 ----
      register int temp;
  
      ptr = ArcDn;
+     if (ptr == ArcDnPtr) return;
      while( (temp=y+ptr->dy) < 0 )
!         if(++ptr == ArcDnPtr )
              return;
  
!     while( (temp<View.ymax) && (ptr!=ArcDnPtr) )
      {   temp = x+ptr->dx;
!         if( XValid(temp) && OValid(ptr->offset) )
          {   dptr = dbase+ptr->offset;  depth = ptr->dz+z;
              SETPIXEL(dptr,fbase+ptr->offset,depth,Lut[ptr->inten+c]);
          }
*** pixutils.h	2004/05/07 19:46:16	1.1
--- pixutils.h	2005/01/16 20:25:16
***************
*** 113,123 ****
--- 128,154 ----
  typedef struct {
          Pixel __huge *fbuf;
          short __huge *dbuf;
+         int   __huge *cbuf;
+         int shift;
          int xmax, ymax;
          int yskip;
+         int offmax;
      } ViewStruct;
  
  
+ typedef struct {
+   int rad;
+   Long x1, y1, z1, x2, y2, z2; 
+   Long U[3]; 
+   int  c1, c2;
+   char altl;
+   Long u1, u2, wp, w1, w2, t1, t2;
+   Long sxyz, syz, sxz;
+   Long Us0Us1, Us0Us0_Us1Us1_Us2Us2, Us0Us0_Us2Us2, Us1Us1_Us2Us2;
+   int s0, s1, s2;
+ } SBDstruct;
+ 
+ 
  #define MAXVERT  6
  typedef struct {
          int x, y, z;
***************
*** 133,138 ****
--- 164,189 ----
  #define ZBack(z)      ((!UseDepthPlane) || ((z)>DepthValue))
  #define XValid(x)     (((x)>=0)&&((x)<View.xmax))
  #define YValid(y)     (((y)>=0)&&((y)<View.ymax))
+ #define OValid(o)     (((o)>=0)&&((o)<View.offmax))
+ 
+ #ifdef INVERT
+ #define InvertY(y) (y)
+ #define ProperY(y) (-(y))
+ #else
+ #define InvertY(y) (-(y))
+ #define ProperY(y) (y)
+ #endif
+ 
+ #define RootSix       2.44948974278
+  
+ /* These define light source position */
+ #define LightDot(x,y,z)  ((x)+InvertY(y)+(z)+(z))
+ #define LightLength      RootSix
+ #define LightXComp       1
+ #define LightYComp       1
+ #define LightZComp       2
+ 
+ 
  
  
  #ifdef PIXUTILS
***************
*** 141,146 ****
--- 192,198 ----
  int FontSize;
  int FontPS;
  int FontStroke;
+ SBDstruct SBD;
  
  #else
  extern ViewStruct View;
***************
*** 148,188 ****
  extern int FontSize;
  extern int FontPS;
  extern int FontStroke;
  #endif
  
! void PlotDeepPoint( int, int, int, int );
  void ClipDeepPoint( int, int, int, int );
- 
- void DrawTwinLine( int, int, int, int, int, int, int, int, char );
  void ClipLine( int, int, int, int, int, int, int,  char );
  void ClipTwinLine( int, int, int, int, int, int, int, int, char );
- void ClipDashLine( int, int, int, int, int, int, int, int, char );
- void DrawTwinVector( int, int, int, int, int, int, int, int, char );
- void ClipVector( int, int, int, int, int, int, int, char );
  void ClipTwinVector( int, int, int, int, int, int, int, int, char );
  void ClipDashVector( int, int, int, int, int, int, int, int, char );
- 
- void DrawCylinder( int, int, int, int, int, int, int, int, int, char, int );
- void ClipCylinder( int, int, int, int, int, int, int, int, int, char, int );
- 
- /* void OutLinePolygon( Poly* ); */
- /* void DrawPolygon( Poly* );    */
- /* void ClipPolygon( Poly* );    */
- 
  void DashRibbon( Knot __far*, Knot __far*, int, int );
! void StrandRibbon( Knot __far*, Knot __far*, int, int );
! void SolidRibbon2( Knot __far*, Knot __far*, int, int );
! void SolidRibbon( Knot __far*, Knot __far*, int );
! void RectRibbon( Knot __far*, Knot __far*, int );
  void DrawSphere( int, int, int, int, int );
- void ClipSphere( int, int, int, int, int );
  void DrawStar( int, int, int, int, int );
! void ClipStar( int, int, int, int, int );
! 
! void ClipTwinLine( int, int, int, int, int, int, int, int, char );
! 
  void SetFontSize( int );
  void SetFontStroke( int );
! void DisplayRasString( int, int, int, unsigned char *, int );
! void InitialisePixUtils( void );
! 
--- 200,236 ----
  extern int FontSize;
  extern int FontPS;
  extern int FontStroke;
+ extern SBDstruct SBD;
  #endif
  
! void ClipCylinder( int, int, int, int, int, int, int, int, int, char, int );
! void ClipDashLine( int, int, int, int, int, int, int, int, char );
  void ClipDeepPoint( int, int, int, int );
  void ClipLine( int, int, int, int, int, int, int,  char );
+ void ClipSphere( int, int, int, int, int );
+ void ClipStar( int, int, int, int, int );
+ void ClipSurfaceBond( int, int, int, int, int, int, int, 
+      int, int, int, int, char);
+ void ClipSurfSphere( int, int, int, int, int );
  void ClipTwinLine( int, int, int, int, int, int, int, int, char );
  void ClipTwinVector( int, int, int, int, int, int, int, int, char );
+ void ClipVector( int, int, int, int, int, int, int, char );
  void ClipDashVector( int, int, int, int, int, int, int, int, char );
  void DashRibbon( Knot __far*, Knot __far*, int, int );
! void DisplayRasString( int, int, int, unsigned char *, int );
! void DrawCylinder( int, int, int, int, int, int, int, int, int, char, int );
  void DrawSphere( int, int, int, int, int );
  void DrawStar( int, int, int, int, int );
! void DrawCircle( void );
! void DrawTorus( int, int, int, int, int, int, int, int, int, int, int, char );
! void DrawSurfSphere( int, int, int, int, int );
! void DrawTwinLine( int, int, int, int, int, int, int, int, char );
! void DrawTwinVector( int, int, int, int, int, int, int, int, char );
! void InitialisePixUtils( void );
! void PlotDeepPoint( int, int, int, int );
! void RectRibbon( Knot __far*, Knot __far*, int );
  void SetFontSize( int );
  void SetFontStroke( int );
! void SolidRibbon2( Knot __far*, Knot __far*, int, int );
! void SolidRibbon( Knot __far*, Knot __far*, int );
! void StrandRibbon( Knot __far*, Knot __far*, int, int );
*** rasmac.c	2004/05/07 19:46:16	1.1
--- rasmac.c	2005/01/16 20:25:17
***************
*** 1377,1382 ****
--- 1383,1399 ----
                                        DisableBackbone();
                                        ReDrawFlag |= RFRefresh;
                                        break;
+ 
+                             case(9):  /* Molecular Surface */
+                                       DrawSurf = True;
+                                       ProbeRadius = 350;
+                                       SetVanWaalRadius( SphereFlag | TouchFlag );
+                                       DisableWireframe();
+                                       SetRibbonStatus(False,0,0);
+                                       DisableBackbone();
+                                       CreateSurfaceBonds();
+                                       ReDrawFlag |= RFRefresh;
+                                       break;
                          }
                          break;              
                              
***************
*** 2041,2046 ****
--- 2058,2064 ----
      register long hand;
      register int code;
      WindowPtr win;
+     GrafPtr savePort;
      
      code = FindWindow(ptr->where,&win);
      switch( code )
***************
*** 2053,2065 ****
          case(inSysWindow):  SystemClick(ptr,win);
                              break;
  
!         case(inContent):    if( win == CanvWin )
!                             {   ClickCanvWin( ptr );
                              } else {
!                               if( win == CmndWin )
!                               {   ClickCmndWin( ptr );
                                }
                              }
                              break;
          
          case(inDrag):       if( (win==CanvWin) 
--- 2071,2104 ----
          case(inSysWindow):  SystemClick(ptr,win);
                              break;
  
!         case(inContent):    // Need to recheck that ptr is in the window
!                             GetPort(&savePort);
!                             SetPort(CanvWin);
!                             GlobalToLocal(&ptr->where);
!                             if((win == CmndWin) || ( win == CanvWin && 
!                                ptr->where.h >=0 && ptr->where.h<=XRange &&
!                                ptr->where.v >=0 && ptr->where.v<=YRange)) {
!                               LocalToGlobal(&ptr->where);
!                               SetPort(savePort);
!                               if( win == CanvWin )
!                               {   ClickCanvWin( ptr );
!                               } else {
!                                 if( win == CmndWin )
!                                 {   ClickCmndWin( ptr );
!                                 }
!                               }
!                               break;
                              } else {
!                               if (win == CanvWin &&
!                                   ptr->where.h >=XRange && ptr->where.h<=XRange+24 &&
!                                   ptr->where.v >=YRange && ptr->where.v<=YRange+24) {
!                                   LocalToGlobal(&ptr->where);
!                                   SetPort(savePort);
!                                   GrowCanvWin( ptr->where );
!                                   break;
                                }
                              }
+                             SetPort(savePort);
                              break;
          
          case(inDrag):       if( (win==CanvWin) 
***************
*** 2454,2459 ****
--- 2493,2499 ----
      ReDrawFlag = RFInitial;
      LabelOptFlag = False;
      CalcBondsFlag = True;
+     CalcSurfFlag = False;
      AllowWrite = False;
  }
  
